library fgu_config;

const String GUKeyIAPType                         = 'GUKeyIAPType';
const String GUKeyGetZAppUse                      = 'GUKeyGetZAppUse';
const String GUKeyGetZAppType                     = 'GUKeyGetZAppType';
const String GUKeyGetZAppStyle                    = 'GUKeyGetZAppStyle';
const String GUKeyGetZAppVersion                  = 'GUKeyGetZAppVersion';

const String kGUKeyAppId                          = 'kGUKeyAppId';
const String kGUKeyAppPlatform                    = 'kGUKeyAppPlatform';
const String kGUKeyAppOldPlatform                 = 'kGUKeyAppOldPlatform';
const String kGUKeyOfficeAccountId                = 'kGUKeyOfficeAccountId';
const String kGUKeyOfficeAccountName              = 'kGUKeyOfficeAccountName';
const String kGUKeyAppFirebaseURL                 = 'kGUKeyAppFirebaseURL';

const String kGUKeyAppClientHost                  = 'kGUKeyAppClientHost';
const String kGUKeyAppAddMeClientHost             = 'kGUKeyAppAddMeClientHost';
const String kGUKeyAppContactUsEmail              = 'kGUKeyAppContactUsEmail';
const String kGUKeyAppSupportEmail                = 'kGUKeyAppSupportEmail';

const String kGUKeyUmengAppKey                    = 'kGUKeyUmengAppKey';

const String kGUKeyJSPatchAppKey                  = 'kGUKeyJSPatchAppKey';
const String kGUKeyJSPatchPublickKey              = 'kGUKeyJSPatchPublickKey';

const String kGUKeyVungleAppId                    = 'kGUKeyVungleAppId';
const String kGUKeyVunglePlacementId              = 'kGUKeyVunglePlacementId';
const String kGUKeyVungleCO                       = 'kGUKeyVungleCO';

const String kGUKeyApplovinAppId                  = 'kGUKeyApplovinAppId';

const String kGUKeyMobvistaAppId                  = 'kGUKeyMobvistaAppId';
const String kGUKeyMobvistaAppKey                 = 'kGUKeyMobvistaAppKey';
const String kGUKeyMobvistaFeedAdUnitId           = 'kGUKeyMobvistaFeedAdUnitId';
const String kGUKeyMobvistaInsertAdUnitId         = 'kGUKeyMobvistaInsertAdUnitId';
const String kGUKeyMobvistaAppWallUnitId          = 'kGUKeyMobvistaAppWallUnitId';

const String kGUKeyPinAdAppKey                    = 'kGUKeyPinAdAppKey';
const String kGUKeyPinAdUnitKey                   = 'kGUKeyPinAdUnitKey';

const String kGUKeyAppsFlyerDevKey                = 'kGUKeyAppsFlyerDevKey';

const String kGUKeyPinPayScheme                   = 'kGUKeyPinPayScheme';
const String kGUKeyPinPayAppId                    = 'kGUKeyPinPayAppId';
const String kGUKeyPinPayAppURL                   = 'kGUKeyPinPayAppURL';
const String kGUKeyPinPayAppName                  = 'kGUKeyPinPayAppName';
const String kGUKeyPinPayAppIcon                  = 'kGUKeyPinPayAppIcon';

const String kGUKeyAdMobAppId                     = 'kGUKeyAdMobAppId';
const String kGUKeyAdMobUnitFC                    = 'kGUKeyAdMobUnitFC';
const String kGUKeyAdMobUnitCO                    = 'kGUKeyAdMobUnitCO';
const String kGUKeyAdMobUnitKey                   = 'kGUKeyAdMobUnitKey';

const String kGUKeyWebPHost                       = 'kGUKeyWebPHost';
const String kGUKeyAdMobInsightItemBannerKey      = 'kGUKeyAdMobInsightItemBannerKey';
const String kGUKeyAdMobOrderCompleteInterstitial = 'kGUKeyAdMobOrderCompleteInterstitial';

const String kGUKeyNeonProductName                = 'kGUKeyNeonProductName';
const String kGUKeyNeonDisplayName                = 'kGUKeyNeonDisplayName';
const String kGUKeyNeonAppType                    = 'kGUKeyNeonAppType';
const String kGUKeyNeonClientHost                 = 'kGUKeyNeonClientHost';
const String kGUKeyEMAppKey                       = 'kGUKeyEMAppKey';
const String kGUKeykAPNCerName                    = 'kGUKeykAPNCerName';

enum FGUConfigSource {
  Remote,
  Default,
}

class FGUConfig {
  factory FGUConfig() => _sharedInstance();
  static FGUConfig _instance;
  FGUConfig._();
  static FGUConfig _sharedInstance() {
    if (_instance == null) {
    _instance = FGUConfig._();
    }
    return _instance;
  }
  Map<FGUConfigSource, Map<String, String>> _configMap = {FGUConfigSource.Remote : {}, FGUConfigSource.Default : {}};

  void setDefaults(Map<String, String> defaults) {
    _innerSetDefaults(defaults, FGUConfigSource.Default);
  }

  String stringValueForKey(String key, {FGUConfigSource source = FGUConfigSource.Default}) {
    return _innerStringValueForKey(key, source);
  }

  List<String> allKeysByDefault({FGUConfigSource source = FGUConfigSource.Default}) {
    return _innerAllKeysFromSource(source);
  }

  void _innerSetDefaults(Map<String, String> defaults, FGUConfigSource source) {
    Map<String, String> configSource = _innerGetConfigWithSource(source);
    if(configSource is Map) {
      configSource.addAll(defaults);
    } else {
      configSource = {}..addAll(defaults);
    }

    _configMap[source] = configSource;
  }

  String _innerStringValueForKey(String key, FGUConfigSource source) {
    Map<String, String> configSource = _innerGetConfigWithSource(source);
    if(configSource is Map) {
      if(configSource[key] is String) {
        return configSource[key];
      }
    }
    return null;
  }

  Map<String, String> _innerGetConfigWithSource(FGUConfigSource source) {
    return _configMap[source];
  }

  List<String> _innerAllKeysFromSource(FGUConfigSource source) {
    Map<String, String> configSource = _innerGetConfigWithSource(source);
    return configSource.keys.toList();
  }

}
